

con { timing }

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq               ' system freq as a constant
  MS_001   = CLK_FREQ / 1_000                                   ' ticks in 1ms
  US_001   = CLK_FREQ / 1_000_000                               ' ticks in 1us


con

  RX1   = 31                                                    ' programming / terminal
  TX1   = 30
  
  SDA   = 29                                                    ' eeprom / i2c
  SCL   = 28

  #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR
  #14, GOTOX, GOTOY, CLS

  c_byteLimit = 100

obj

  n : "numbers"
  debug : "fullduplexserial"
  s : "strings"
  s2 : "strings2"
  s3 : "ascii0_strengine_1"

var

  long bin1
  long bin2

  word actuatorPosition
  byte actuatorPositionHigh
  byte actuatorPositionLow
  
  long byte1
  long byte2

  byte byteArr[4]

  byte b_RxString[c_byteLimit]
  byte b_prefix[c_byteLimit]
  byte b_suffix[c_byteLimit]
  byte b_waitingToBeParsed[c_byteLimit]

    byte  r[4]

pub main | int, binary1, binary2

  debug.start(RX1, TX1, %0000, 115_200)
  Waitcnt ((clkfreq * 2) + cnt)

  int := 500

   
  debug.tx(CLS)    

  debug.str(string( "Starting "))
  debug.tx(13)
  
  repeat

    debug.dec(cnt)
    debug.tx(13)
    
    split(cnt, @r{0})

    debug.dec(r[0])
    debug.tx(13)
    debug.dec(r[1])
    debug.tx(13)
    debug.dec(r[2])
    debug.tx(13)
    debug.dec(r[3])
    debug.tx(13)
    debug.tx(13)
    
    
    debug.tx(13)
    debug.tx(13)
    waitcnt(clkfreq + cnt)
 

PRI split(value, storage) : i

  repeat 4
    byte[storage++] := value.byte[i++]
          

  